/*
   test for 1GB file-limits
   
   file limit depends on filesystem (inode size)
   type of size_t (libc, compiler)

   ex:
       linux-2.4.12 + ext2 + gcc           = 2GB (program exits with error message)
       linux-2.4.12 + ext2 + gcc + fopen64 > 5GB sizeof(size_t)=4
       IRIX64 + hpfs?      + CC (-n32/-64) > 3GB sizeof(size_t)=4/8
   
 */
#include <stdio.h>
#include <stdlib.h>

main(){
  FILE *f1;
  char *buf;
  size_t t1,t2,t3,i;
  t2=t1=1024*1024*10;
  printf("sizeof(size_t)=%d %.1e %.1e\n",sizeof(size_t),(double)t1,(double)t2);
  buf=(char *)malloc(t1);
  for(i=0;i<t1;i++)buf[i]=0;
  if (!buf) { printf("error malloc\n");exit(1); }
  f1=fopen("/dev/null","a+b");
  if (!f1) { printf("error fopen\n");exit(1); }
  for (i=0; i<500; i++){
    printf(" %d",(int)i);fflush(stdout);
    t3=fwrite(buf,1,t1,f1);
    if (t3!=t1) { printf("\nerror fwrite %d = %e\n",(int)i,(double)t3);exit(1); }
 }
 fclose(f1);
 printf(" ok\n");
}
